.386
.model flat,stdcall
option casemap:none

include Wallet.inc

.code

start:

	invoke GetModuleHandle, NULL
	mov		hInstance, eax
	invoke InitCommonControls		
	invoke DialogBoxParam,hInstance,IDD_TABTEST,NULL,addr DlgProc,NULL
	invoke ExitProcess,eax 

Tab1Proc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_INITDIALOG
	.elseif uMsg == WM_COMMAND
		mov		eax,wParam
		.if ax == IDC_BTNBrowse
			invoke BrowseForFolder,hWin,ADDR FilePath,ADDR Msg_Browse,ADDR Msg_Folder
            .if FilePath[0] != 0
            	invoke	SetDlgItemText,hWin,IDC_DBPath,Addr FilePath 
            	invoke	SendMessage,hEditPath,WM_SETTEXT,0,Addr FilePath
            .endif
		.endif
		
		;****	Check for clicked buttons	****
		.if lParam != 0
			;****	Event has happened	****
			.if ax == IDC_BTNAccept
				;*====	Accept button clicked	====
				invoke GetDlgItemText,hWin,IDC_Pass,ADDR PassWord,63
				invoke GetDlgItemText,hWin,IDC_SetConfirm,ADDR CPassWord,63

				mov		esi,offset PassWord		; ESI -> password
				mov		edi,offset CPassWord	; EDI -> confirm string
				sub		dx,dx					; case sensitive

				;*====	Compare if the passwords are identical	====
				call	cmp_ASCIIz				; compare the two strings
				
				.if eax == 0
					invoke MessageBox,hWin,ADDR Msg_PassSame,ADDR AppName,MB_OK
				.else
					invoke MessageBox,hWin,ADDR Msg_PassDiff,ADDR AppName,MB_OK
				.endif
			.elseif ax == IDC_BTNSave
				;*====	Save configuration button clicked	====
				call	save_Sys				; save system record
			.endif
		.endif 
	.elseif uMsg == WM_CHAR
		mov eax,wParam
		
		.if (al == VK_TAB) || (al == VK_RETURN)
			;*====	Return or TAB key	====
			invoke	GetDlgCtrlID, hWin
			
			.if ax == IDC_Pass				; password edit control
				invoke	SetFocus,hEd_Pass
			.elseif ax == IDC_SetConfirm	; confirm password edit control
				invoke	SetFocus,hBtnAccept
			.endif
		.endif 
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

Tab1Proc endp

Tab2Proc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_INITDIALOG
	.elseif uMsg == WM_COMMAND
		;*******************************************
		;*===	Check for the various buttons	====
		;*******************************************
		mov		eax,wParam
		.if ax == IDC_BTNAdd
			;****	Add new website information to the database	****
			invoke GetDlgItemText,hWin,IDC_EDTWebsite,ADDR Website,127
			invoke GetDlgItemText,hWin,IDC_EDTURL,ADDR URL,127
			invoke GetDlgItemText,hWin,IDC_EDTUName,ADDR UserName,63
			invoke GetDlgItemText,hWin,IDC_EDTPass,ADDR WebPass,63
			invoke GetDlgItemText,hWin,IDC_EDTRemark,ADDR Remarks,127

			.if (URL[0] != 0) && (UserName[0] != 0) && (WebPass [0] != 0)
				;*====	Check if the website already defined in the database	====
				mov		ecx,WRecords				; load the total record count
				cmp		ecx,0						; no records? 
				je		noWeb						; Yes, insert
				
				mov		esi,offset WData			; ESI -> database
				add		esi,128						; ESI -> URL field
				mov		edx,1						; case insensitive
				mov		edi,offset URL				; point to the URL
				
				;*====	Search loop	====
			scanlp:
				push	ecx							; save record count
				
				call	cmp_ASCIIz					; check if the same
				
				pop		ecx							; restore ECX
				cmp		eax,0						; the same
				jne		nextRec						; continue with next record
				
				;*====	Inform same URL found	====
				invoke 	MessageBox,hWin,ADDR Msg_DupURL,ADDR AppName,MB_YESNO
				
				cmp		eax,IDYES					; insert into database
				je		noWeb						; continue

				invoke 	MessageBox,hWin,ADDR Msg_NoAdd,ADDR AppName,MB_OK
				jmp		noAdd						; exit from exit				
				
				;*====	Search the next url field	====
			nextRec:
				add		esi,WRecSize				; go to next record's URL
				dec		ecx							; decrement record count
				jne		scanlp						;
				
				;*====	Save the website record information into the database	====
			noWeb:
				call	Add_WRec					; insert new record into the database
				call	dsp_lview					; display the new inserted record
       			invoke	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_Buf
				mov		[bChanged],0				; reset database changed flag
				invoke	SetDlgItemInt,hWin,IDC_STCCount,WRecords,0
			.else
       			invoke	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_InvData
			.endif
			noAdd: 			
		.elseif ax == IDC_BTNDel
			;****	Delete current website information from the database	****
			cmp		[WRecords],0					; there are records to delete
			je		NoRecDel						; No records to delete
			
			call	Del_WRec						; delete current record
		NoRecDel:
		.elseif ax == IDC_BTNUp
			;****	Go to previous website information to the database	****
			cmp		[WCurIndex],0					; check if at top of database
			je		atTop							; already at top
	
			;*====	Copy the data in database into memory for display	====
			dec		[WCurIndex]						; decrement index record
		showRec:	 
			call	ShowWRecord						; copy from database into memory buffer
			
           	invoke	SetDlgItemText,hWin,IDC_EDTWebsite,Addr Website 
           	invoke	SetDlgItemText,hWin,IDC_EDTURL,Addr URL 
           	invoke	SetDlgItemText,hWin,IDC_EDTUName,Addr UserName 
           	invoke	SetDlgItemText,hWin,IDC_EDTPass,Addr WebPass 
           	invoke	SetDlgItemText,hWin,IDC_EDTRemark,Addr Remarks 
		atTop:
		.elseif ax == IDC_BTNDown
			;****	Go to next website information to the database	****
			mov		eax,[WCurIndex]					; EAX = current index number
			inc		eax								; adjust for one based
			cmp		eax,[WRecords]					; reached the bottom of database?
			jae		atBottom						; Yes, ignore
			
			inc		[WCurIndex]						; increment record index
			jmp		showRec	
		atBottom:									; 
		.elseif ax == IDC_BTNTop
			;****	Go to the top record website information to the database	****
			mov		[WCurIndex],0					; reset to 1st record
			jmp		showRec							; 
		.elseif ax == IDC_BTNBottom
			;****	Go to the last website information to the database	****
			mov		eax,[WRecords]					; get total record count
			dec		eax								; adjust for zero based
			mov		[WCurIndex],eax					; save the index record number
			jmp		showRec							; 
		.endif 
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

Tab2Proc endp

Tab3Proc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  			LOCAL 	lvc:LV_COLUMN 

	.if uMsg==WM_INITDIALOG
		invoke GetDlgItem,hWin,IDC_LSVPass		; listview control
		mov		[hListView],eax

		;*====	Call routine to create the columns in the listview control	====
		invoke	InsertColumn,hListView 

		;*====	Set up the header	====
		invoke 	SendMessage,hListView,LVM_GETHEADER, 0, 0   ;// get handle to header 
		mov 	hHeader,eax   						;// preserve header handle 
		invoke 	GetWindowLong, hHeader, GWL_STYLE   ;// get current window styles 
		xor 	eax,HDS_BUTTONS 
		invoke 	SetWindowLong,hHeader, GWL_STYLE, eax   ;// set the new header styles 
	
		;/* Setup extended styles like gridlines, back-foregroundcolors */
		mov   	 eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES

		invoke   SendMessage, hListView, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
		invoke   SendMessage, hListView, LVM_SETTEXTCOLOR, 0, 00000000h
		invoke   SendMessage, hListView, LVM_SETBKCOLOR, 0, 00FFFFFFh
		invoke   SendMessage, hListView, LVM_SETTEXTBKCOLOR, 0,00A6F7F0h
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

Tab3Proc endp

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	ts:TC_ITEM

	mov		eax,uMsg
	.if eax==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		and		eax,0FFFFh
		shr		edx,16
		.if edx==BN_CLICKED
			;*====	Exit if Quit button is clicked	====
			.if eax==IDQuit
				invoke SendMessage,hWin,WM_CLOSE,0,0
			.elseif eax==IDDone
				;*====	Save system records first	====
				.if bChanged != 0
					call	save_DB						; save database
					call	save_Sys					;  & system record
					.if eax == 0
						invoke MessageBox,hWin,ADDR Msg_SysWrOK,ADDR AppName,MB_OK
       					invoke SendMessage,hStatus,SB_SETTEXT,0,offset Msg_SysWrOK
					.else
						invoke MessageBox,hWin,ADDR Msg_SysWrErr,ADDR AppName,MB_OK
       					invoke SendMessage,hStatus,SB_SETTEXT,0,offset Msg_SysWrErr
					.endif
				.endif
	
				invoke SendMessage,hWin,WM_CLOSE,0,0
			.endif
		.endif

		;****	Check for menu command	====
		.if ax == IDM_FILE_SAVEDB
			;****	Save the database	****
			mov		esi,offset FilePath			; file path
			mov		edi,offset FPath			; working path
			mov		ebx,offset DB_FileName		; database filename
			call	combine_path_file			; concentanate file name, path into working path

			mov		ebx,offset FPath			; file path
			mov		edi,offset WData			; EDI -> database
			mov		eax,WRecords				; record count
			mov		bx,WRecSize
			mul		bx
			mov		ecx,eax						; ECX = bytes to save

			call	save_DB						; save the database
			
			.if eax != 0
				;*====	Error in saving database
				.if eax == -1
					invoke MessageBox,hWin,ADDR Msg_WriteOErr,ADDR AppName,MB_OK
				.elseif eax == -2
					invoke MessageBox,hWin,ADDR Msg_WriteNErr,ADDR AppName,MB_OK
				.elseif eax == -3
					invoke MessageBox,hWin,ADDR Msg_WriteWErr,ADDR AppName,MB_OK
				.endif
			.else
				invoke MessageBox,hWin,ADDR Msg_WriteOK,ADDR AppName,MB_OK
			.endif	
		.elseif ax == IDM_FILE_LOADDB
			;****	Load the database	****
			mov		esi,offset FilePath			; file path
			mov		edi,offset FPath			; working path
			mov		ebx,offset DB_FileName		; database filename
			call	combine_path_file			; concentanate file name, path into working path
			
			mov		ebx,offset FPath			; file path
			mov		edi,offset WData			; EDI -> database
			mov		eax,WRecords				; record count
			mov		bx,WRecSize
			mul		bx
			mov		ecx,eax						; ECX = bytes to save

			call	load_DB						; save the database
			
			.if eax != 0
				;*====	Error in saving database
				.if eax == -1
					invoke MessageBox,hWin,ADDR Msg_LoadErr,ADDR AppName,MB_OK
				.endif
			.else
				invoke MessageBox,hWin,ADDR Msg_LoadOK,ADDR AppName,MB_OK
			.endif	
		.elseif ax == IDM_FILE_LOADSYS
			;****	Load the system record	****
			call	load_Sys
		.elseif ax == IDM_FILE_SAVESYS
			;****	Save the system record	****
			call	save_Sys
		.endif
	.elseif eax==WM_NOTIFY
		mov		eax,lParam
		mov		eax,[eax].NMHDR.code
		.if eax==TCN_SELCHANGE
			;Tab selection
			invoke SendMessage,hTab,TCM_GETCURSEL,0,0
			.if eax!=SelTab
				push	eax
				mov		eax,SelTab
				invoke ShowWindow,[hTabDlg+eax*4],SW_HIDE
				pop		eax
				mov		SelTab,eax
				invoke ShowWindow,[hTabDlg+eax*4],SW_SHOWDEFAULT
			.endif
		.endif
	.elseif eax==WM_INITDIALOG
		;Create the tabs
		invoke GetDlgItem,hWin,IDC_TAB1
		mov		hTab,eax
		mov		ts.imask,TCIF_TEXT
		mov		ts.lpReserved1,0
		mov		ts.lpReserved2,0
		mov		ts.iImage,-1
		mov		ts.lParam,0
		mov		ts.pszText,offset TabTitle1
		mov		ts.cchTextMax,sizeof TabTitle1
		invoke SendMessage,hTab,TCM_INSERTITEM,0,addr ts
		mov		ts.pszText,offset TabTitle2
		mov		ts.cchTextMax,sizeof TabTitle2
		invoke SendMessage,hTab,TCM_INSERTITEM,1,addr ts
		mov		ts.pszText,offset TabTitle3
		mov		ts.cchTextMax,sizeof TabTitle3
		invoke SendMessage,hTab,TCM_INSERTITEM,2,addr ts
		
		;Create the tab dialogs
		invoke CreateDialogParam,hInstance,IDD_TAB1,hTab,addr Tab1Proc,0
		mov 	hTabDlg,eax
		invoke CreateDialogParam,hInstance,IDD_TAB2,hTab,addr Tab2Proc,0
		mov 	hTabDlg[4],eax
		invoke CreateDialogParam,hInstance,IDD_TAB3,hTab,addr Tab3Proc,0
		mov 	hTabDlg[8],eax

		;*====	Get current directory application is in	====
		mov		esi,offset WalletPath
		mov		edi,offset FilePath
		call	copy_ASCIIz		
		;invoke	GetCurrentDirectory, 128, offset FilePath
		
		invoke	init_Wallet,hWin				; initialize wallet environment

		;*====	Display the record count	====
		invoke	SetDlgItemInt,hWin,IDC_STCCount,WRecords,0
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,NULL
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

;*==================================================================================*
;*			Routine to setup the environment for this programm to work				*
;*==================================================================================*
init_Wallet	proc	hWin:HWND
			;*====	Get handle to TAB 1 controls	****	
			invoke GetDlgItem,hWin,IDC_DBPath		; database path edit control
			mov		hEditPath,eax
			invoke GetDlgItem,hWin,IDC_BTNBrowse	; database path edit control
			mov		hBtnBrowse,eax

			invoke GetDlgItem,hWin,IDC_Pass			; password edit control
			mov		hEd_Pass,eax
	
			invoke GetDlgItem,hWin,IDC_SetConfirm	; confirm password edit control
			mov		hEd_Confirm,eax		

			invoke GetDlgItem,hWin,IDC_BTNSave		; save configuration button control
			mov		hSaveConf,eax		

			invoke GetDlgItem,hWin,IDC_BTNAccept	; password button control
			mov		hBtnAccept,eax		

			;*====	Get handle to TAB 2 controls	****	
			invoke GetDlgItem,hWin,IDC_EDTWebsite	; website edit control
			mov		hWebsite,eax

			invoke GetDlgItem,hWin,IDC_EDTURL		; website url edit control
			mov		hURL,eax

			invoke GetDlgItem,hWin,IDC_EDTUName		; website user name edit control
			mov		hUserName,eax

			invoke GetDlgItem,hWin,IDC_EDTPass		; website edit control
			mov		hWebPass,eax

			invoke GetDlgItem,hWin,IDC_EDTRemark	; website edit control
			mov		hRemark,eax

			invoke GetDlgItem,hWin,IDC_STCCount		; recordcount label control
			mov		hWCount,eax

			invoke GetDlgItem,hWin,IDC_SBR1			; statusbar
			mov		hStatus,eax

			call	load_Sys						; save the system record
			
			.if eax == 0
				invoke MessageBox,hWin,ADDR Msg_SysLdOK,ADDR AppName,MB_OK
			.else
				invoke MessageBox,hWin,ADDR Msg_SysLdErr,ADDR AppName,MB_OK
			.endif
	
			mov		[bChanged],0					; reset database changed flag
	       	invoke SendMessage,hStatus,SB_SETTEXT,0,offset Msg_Welcome

			;*====	Display the record count	====
       		invoke	SetDlgItemInt,hWin,IDC_STCCount,WRecords,NULL

			ret

init_Wallet endp

;*==================================================================================*
;*			Routine to insert the new website record into the listview				*
;*==================================================================================*
dsp_lview	proc	;hWnd:DWORD
			;*====	Prepare to insert a new row	====
			mov 	lvi.imask,LVIF_TEXT+LVIF_PARAM	; preset the listview to text parameters
			mov		eax,[WCurIndex]					; get row number
			dec		eax								; decrement for zero based number
			mov 	lvi.iItem,eax					; insert the row number
			mov	 	lvi.lParam,eax					; set the user value
			mov 	lvi.iSubItem,0					; 1st field 
			mov 	lvi.pszText,offset Website		; website name 
			invoke 	SendMessage, hListView, LVM_INSERTITEM,0, addr lvi

			;*====	Insert the next column - URL	----			
			mov 	lvi.imask,LVIF_TEXT				; preset the listview to text parameters
			mov 	lvi.iSubItem,01					; field #1
			mov 	lvi.pszText,offset URL			; ptrs to road name
			invoke 	SendMessage, hListView, LVM_SETITEM,0, addr lvi
				
			mov 	lvi.iSubItem,02					; field #2
			mov 	lvi.pszText,offset UserName		; ptrs to bus stop name
			invoke 	SendMessage, hListView, LVM_SETITEM,0, addr lvi

			;mov 	lvi.iSubItem,03					; field #3
			;mov 	lvi.pszText,offset b_Landmark	; ptrs to landmark name
			;invoke 	SendMessage, hlv, LVM_SETITEM,0, addr lvi
	
			ret

dsp_lview 	endp

;*==================================================================================*
;*			Routine to display the whole database in listview						*
;*==================================================================================*
dsp_db_lview proc
	
	
			ret

dsp_db_lview endp

;****=======================================================================****
;****			Routine to compare two strings case sensitive null string	****
;****-----------------------------------------------------------------------****
;****			Input:	ESI -> String 1										****
;****					EDI -> String 2										****
;****					DX =  0 case sensitive, 1 = case insensitive		****					
;****																		****
;****			Output:	EAX = 0	Same										****
;****						= 1 Different									****
;****																		****
;****			Registers preserved:	ESI, EDI							****
;****			Registers corrupted:	EAX									****
;****=======================================================================****
cmp_ASCIIz	proc
			push	esi						; save ESI
			push	edi						;  & EDI
			
			;*====	Setup environment for compare	====
		cmplp:
			mov		al,[esi]				; get character
			cmp		al,0					; null character?
			je		cmpsame					; Yes, then string 
			
			mov		ah,[edi]				; get string 2 character
			cmp		al,0					; null character?
			je		cmpdiff					; Yes, then exit
			
			cmp		dx,0					; case sensitive?
			je		cmpcase					; Yes, do case sensitive
			
			and		ax,5F5Fh				; make it case insensitive

			;*====	Compare characters	====
		cmpcase:
			cmp		al,ah					; same?
			jne		cmpdiff					; No, different
			
			;*====	Go to next character	====
			inc		esi						; increment pointers
			inc		edi						;
			jmp		cmplp					;
			
			;*====	Restore stack	====
		cmpex:
			pop		edi						; restore EDI
			pop		esi						;  & ESI
			ret

			;*====	Strings are different	====
		cmpdiff:
			mov		eax,1					; return different status
			jmp		cmpex					; Exit
			
			;*====	Check if 2nd string also EOS	====
		cmpsame:
			mov		ah,[edi]				; get string 2 character
			cmp		al,0					; null character?
			jne		cmpdiff					; No, then string is different
			
			sub		eax,eax					; string is the same
			jmp		cmpex					; exit
cmp_ASCIIz 	endp

;*==================================================================================*
;*			Routine to get the string length of a string (ASCIIz string)			*
;*----------------------------------------------------------------------------------*
;*			This routine will determine the length of the ASCIIz string.			*
;*																					*
;*			Input:  ESI -> Source buffer											*
;*																					*
;*			Output:	ECX = String length	(one based)									*
;*==================================================================================*
get_strlen		proc
				push	esi						; save ptr
				sub		ecx,ecx					; reset ECX
		getstrlp:
				cmp		byte ptr [esi],0		; ASCIIz character?
				je		getstrex				; Yes, then exit
				
				inc		ecx						; increment length
				inc		esi						;  & ptr
				jmp		getstrlp				; continue till ASCIIz character is found

		getstrex:
				pop		esi						;
				ret
get_strlen		endp

;*==================================================================================*
;*			Routine to copy ASCIIz string from source to destination				*
;*----------------------------------------------------------------------------------*
;*			Routine to copy the source string into the destination and 				*
;*			register are not preserved												*
;*																					*
;*			Input:	ESI -> Source string											*
;*					EDI -> Destination buffer										*
;*																					*
;*			Output:	ECX = String length copied										*
;*==================================================================================*
copy_null	proc
			mov		al,[esi]					; get character
			cmp		al,00						; null character
			je		copyNex						; Yes, then exit
			
			mov		[edi],al					; save character in destination  buffer
			inc		ecx							; increment ECX
			inc		esi							; increment pointers
			inc		edi
			jmp		copy_null					; copy  				
	
			;*====	Restore pointers	====
		copyNex:
			ret

copy_null 	endp
;*==================================================================================*
;*			Routine to copy ASCIIz string from source to destination				*
;*----------------------------------------------------------------------------------*
;*			Input:	ESI -> Source string											*
;*					EDI -> Destination buffer										*
;*					ECX = Start destination string length							*
;*																					*
;*			Output:	ECX = String length copied										*
;*==================================================================================*
copy_ASCIIz	proc
			push	esi							; save pointers
			push	edi							;
			
			;*====	Copy string	====
		copylp:
			mov		ah,al						; copy previous character in AL
			mov		al,[esi]					; get character
			cmp		al,00						; null character
			je		copyex						; Yes, then exit
			
			mov		[edi],al					; save character in destination  buffer
			inc		ecx							; increment ECX
			inc		esi							; increment pointers
			inc		edi
			jmp		copylp						; copy  				
	
			;*====	Restore pointers	====
		copyex:
			pop		edi
			pop		esi
			ret
copy_ASCIIz endp

;*==================================================================================*
;*			Routine to concatenate two strings										*
;*----------------------------------------------------------------------------------*
;*			This routine will save the database 							  		*
;*																					*
;*			Input:  EDI -> Main string												*
;*					ESI -> String 2 to write into main string 						*
;*																					*
;*			Output:	EAX = 	0 OK													*
;*							-1 Error												*
;*==================================================================================*
concatASCIIz proc
			;*====	Move pointer to end of ASCIIz string	====
		movelp:
			cmp		byte ptr [edi],00				; check if end of string
			je		endStr							; Yes, done
			
			inc		edi								; increment pointer
			jmp		movelp							; continue
			
			;*====	End of string reached. Copy the rest	====
		endStr:		
			call	copy_ASCIIz						; copy the second string into main string
			ret

concatASCIIz endp	


;*==================================================================================*
;*			Routine to concatenate a file name into file path						*
;*----------------------------------------------------------------------------------*
;*			This routine will save the database 							  		*
;*																					*
;*			Input:  EDI -> Main buffer												*
;*					ESI -> File name				 								*
;*																					*
;*			Output:	ECX = Main string length used									*
;*																					*
;*			Registers corrupted: EDI, ESI											*
;*==================================================================================*
concat_File	proc
			push	edi								; save the main buffer
			
			sub		ecx,ecx							; reset ECX
			sub		eax,eax							; reset EAX

			;*====	Move pointer to end of ASCIIz string	====
		movelp:
			cmp		byte ptr [edi],00				; check if end of string
			je		cendStr							; Yes, done

			mov		al,[edi]						; get the character before EOS			

			inc		ecx								; increment count
			inc		edi								; increment pointer
			jmp		movelp							; continue
			
			;*====	End of string reached. Copy the rest	====
		cendStr:
			cmp		al,5Ch							; last character a path delimiter?
			je		delimt							; Yes, then ignore adding one
					
			mov		byte ptr [edi],5Ch				; include the 
			inc		ecx								; increment length
			inc		edi								; increment ptr
		delimt:
			call	copy_ASCIIz						; copy the file name
			
			pop		edi								; restore the pointer	
			ret

concat_File endp

;*==================================================================================*
;*			Routine to concatenate path, file name into file path					*
;*----------------------------------------------------------------------------------*
;*			This routine will save the database 							  		*
;*																					*
;*			Input:  EDI -> Main string												*
;*					ESI -> Path name				 								*
;*					EBX -> File name												* 					
;*																					*
;*			Output:	ECX = Main string length used									*
;*																					*
;*			Registers corrupted: EDI, ESI											*
;*==================================================================================*
combine_path_file proc
			sub		ecx,ecx						; reset start length
			call	copy_ASCIIz					; copy into path into working path

			mov		esi,ebx						; system filename
			call	concat_File					; concentanate file name into path

			ret

combine_path_file endp

;*==================================================================================*
;*			Routine to fetch the record from the database into memory buffer		*
;*----------------------------------------------------------------------------------*
;*			This routine will save all the website information and save it  		*
;*			into the database.														*
;*																					*
;*			Input:  WCurIndex variables (ero based)									*
;*																					*
;*			Output:	Website information will be updated								*
;*==================================================================================*
ShowWRecord	proc
			mov		bx,WRecSize					; get record byte size
			mov		eax,WCurIndex				;  & record index
			mul		bx							; EAX = offset
			mov		esi,offset WData			; ESI -> wallet database
			add		esi,eax						; ESI -> record
			
			mov		edi,offset Website			;  
			call	copy_ASCIIz					; copy website name into record
			
			add		esi,128						; skip to next field
			mov		edi,offset URL				; ESI -> URL address
			call	copy_ASCIIz					; copy URL field into record
			
			add		esi,128						; skip to next field
			mov		edi,offset UserName			; ESI -> user name
			call	copy_ASCIIz					; copy URL field into record
			
			add		esi,64						; skip to next field
			mov		edi,offset WebPass			; ESI -> password
			call	copy_ASCIIz					; copy URL field into record
			
			add		esi,64						; skip to next field
			mov		edi,offset Remarks			; ESI -> remark
			call	copy_ASCIIz					; copy URL field into record
			ret
ShowWRecord endp

;*==================================================================================*
;*			Routine to get the add the record into the database						*
;*----------------------------------------------------------------------------------*
;*			This routine will save all the website information and save it  		*
;*			into the database.														*
;*																					*
;*			Input:  Website variables 												*
;*																					*
;*			Output:	WRecords, WData, WCurIndex will be updated						*
;*==================================================================================*
Add_WRec	proc
			mov		edi,offset WData			; ESI -> wallet database
			mov		ebx,WRecSize				; record byte size
			mov		eax,WRecords				; EAX = total record count

			cmp		eax,0						; any record defined?
			je		NoRec						; No, then continue
			
			mul		bx							; get record offset 
		NoRec:
			add		edi,eax						; EDI -> next free location
			
			;*====	Clear the destination buffer first	====
			push	edi							; save pointer
			
			mov		ecx,WRecSize				; ECX =record byte size
			sub		al,al						; clear AL
			rep		stosb						; 
			
			pop		edi							; restore EDI
			
			;*====	Copy each field into database field	====
			mov		esi,offset Website			;  
			call	copy_ASCIIz					; copy website name into record
			
			add		edi,128						; skip to next field
			mov		esi,offset URL				; ESI -> URL address
			call	copy_ASCIIz					; copy URL field into record
			
			add		edi,128						; skip to next field
			mov		esi,offset UserName			; ESI -> user name
			call	copy_ASCIIz					; copy URL field into record
			
			add		edi,64						; skip to next field
			mov		esi,offset WebPass			; ESI -> password
			call	copy_ASCIIz					; copy URL field into record
			
			add		edi,64						; skip to next field
			mov		esi,offset Remarks			; ESI -> remark
			call	copy_ASCIIz					; copy URL field into record
			
			mov		eax,WRecords				; get current record index
			mov		WCurIndex,eax				; make it current
			inc		eax							; increment total record count
			mov		WRecords,eax				; save the record count
			
			;*====	Setup display buffer for display	====
			mov		ecx,63						;
			sub		eax,eax
			mov		edi,offset Msg_Buf			; EDI -> buffer to display message
			rep		stosd						; clear display buffer
			
			mov		edi,offset Msg_Buf			; EDI -> buffer to display message
			mov		esi,offset Col_Website		; ESI -> website message
			call	copy_null					; copy website msg
			mov		byte ptr [edi],3Ah			; insert ":"
			mov		byte ptr [edi+1],20h		; insert space
			mov		byte ptr [edi+2],27h		; insert "'"
			add		edi,3						; update ptr
			mov		esi,offset Website			; ESI -> point to website name
			call	copy_null					; copy into display buffer
			mov		byte ptr [edi],27h			; insert "'"
			inc		edi
			mov		esi,offset Msg_Ins			; ESI -> inserted message
			call	copy_null					; copy into display buffer
			
			mov		byte ptr [edi],0			; insert null character
			
			ret
Add_WRec 	endp

;*==================================================================================*
;*			Routine to get the add the record into the database						*
;*----------------------------------------------------------------------------------*
;*			This routine will save all the website information and save it  		*
;*			into the database.														*
;*																					*
;*			Input:  WCurIndex variables - current record index						*
;*																					*
;*			Output:	WRecords, WData, WCurIndex will be updated						*
;*==================================================================================*
Del_WRec	proc
			mov		eax,WRecords				; EAX = total records in database
			sub		eax,WCurIndex				; EAX = Total - current = number of records to move
			mov		edx,eax						; copy into EDX 
			dec		eax							; adjust for zero based index
			mov		ebx,WRecSize				; record byte size
			
			mul		bx							;
			
			;*====	Number of bytes to move into deleted area	====  
			mov		ecx,eax						; ECX = number of bytes to move
			 	
			mov		eax,edx						; current record index
			mul		bx							; EAX = offset to current record 		
			mov		esi,offset WData			; ESI -> wallet database
			add		esi,eax						; point to start of record
			mov		edi,esi						; copy into EDI
			add		esi,WRecSize				; go to next record
			
			cld									; downward direction
			rep		movsb						; copy data

			dec		WRecords					; decrement total record
			
			mov		eax,WCurIndex				; EAX = current record
			cmp		eax,WRecords				; current index record out of database?
			jb		DelRex						; No, then continue
			
			;*====	Ensure current index record is within the database	====  
			mov		eax,WRecords				; get total record 
			dec		eax
			mov		WCurIndex,eax				;
		DelRex: 
			call	ShowWRecord					; display new record 
			ret

Del_WRec 	endp

;*==================================================================================*
;*			Routine to get the save a data											*
;*----------------------------------------------------------------------------------*
;*			This routine will save the database 							  		*
;*																					*
;*			Input:  EBX -> File path												*
;*					EDI -> Database 												*
;*					ECX = Bytes to save												*
;*																					*
;*			Output:	EAX = 	0 OK													*
;*							-1 Error												*
;*==================================================================================*
save_DB		proc
			push	edi							; save registers
			push	ecx							;
										
			invoke	CreateFile, ebx, GENERIC_WRITE, FILE_SHARE_READ, 0, \
					CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0

			cmp		eax,INVALID_HANDLE_VALUE 	; does the file exits?
			je		savedberr			 		;
			
			mov		[hFile],eax					; save file handle
			
			pop		ecx							; restore byte to save
			pop		edi							; pointer to database
			
			push	ecx							; save size
			 
			;*----	WriteFile, hFile, Buffer, Bytes to save, bytes saved	----
			invoke	WriteFile, eax, edi, ecx, offset i_byteread, 00

			pop		ecx							; ECX = bytes to save
			cmp		ecx,[i_byteread]			; same number of bytes saved
			jne		savedb_byterr				; number of bytes saved error
			
			cmp		eax,FALSE					; save OK?
			je		writeError					; No, error
			
			invoke	CloseHandle, hFile			; close file
			sub		eax,eax						; return OK status
		saveEx:
			pop		edi
			ret

			;*====	Error opening file for write	====
		savedberr:
			mov		eax,-1						;return error
		saveErrCode:
			push	eax							; save return code
			
			invoke	CloseHandle, hFile			; close file
       	    invoke	GetLastError				;
       	    mov		[FileError],eax
       	    
       	    pop		eax							; get return code back
			jmp		saveEx

			;*====	Error in byte written count	====
		savedb_byterr:
			mov		eax,-2						;return error
			jmp		saveErrCode
		
			;*====	Unable to save file	====
		writeError:
			mov		eax,-3						;return error
			jmp		saveErrCode
		
save_DB 	endp

;*==================================================================================*
;*			Routine to get the load a database										*
;*----------------------------------------------------------------------------------*
;*			This routine will load the database 							  		*
;*																					*
;*			Input:  EBX -> File path												*
;*					EDI -> Database 												*
;*					ECX = Bytes to load												*
;*																					*
;*			Output:	EAX = 	0 OK													*
;*							-1 Error												*
;*==================================================================================*
load_DB		proc
			push	edi
			push	ecx
	
			;*====	Open file for read operation	====
			invoke	CreateFile, ebx, GENERIC_READ, FILE_SHARE_READ, 0, \
					OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0

			cmp		eax,INVALID_HANDLE_VALUE ; does the file exits?
			je		loadDBerr				 ;
					
			;*----	Valid file and is to be read	-----
			mov		[hFile],eax				; save file handle

			pop		ecx						; restore read byte count
			pop		edi						;  & destination buffer
			
			push	ecx						; save count again for use later
			
			;*----	Read the whole file into file buffer	----
			;*----	ReadFile, hFile, lpBuffer, NoofBytesToRead, NoofBytesRead, lpOverlapped
			invoke	ReadFile, hFile, edi, ecx, offset i_byteread, 00
				
			cmp		eax,FALSE				; read operation error
			je		loadDBerr				; process error

			invoke	CloseHandle, hFile		; close file
			sub		eax,eax					; done

			;*====	Prepare to exit - restore stack	====
	loadEx:
			pop		ecx
			pop		edi
			ret

	loadDBerr:
			invoke	CloseHandle, hFile		; close file
			mov		eax,-1					; error loading file
       	    invoke	GetLastError			;
			jmp		loadEx
load_DB 	endp



;*==================================================================================*
;*			Routine to get the load system record									*
;*==================================================================================*
load_Sys	proc
			mov		esi,offset FilePath			; file path
			mov		edi,offset FPath			; working path
			mov		ebx,offset Sys_FileName		; system filename
			call	combine_path_file			; concentanate file name, path into working path

			mov		ebx,edi			
			mov		edi,offset WRecords			; EDI -> database
			mov		ecx,320						; record count

			call	load_DB
		
			ret

load_Sys 	endp

;*==================================================================================*
;*			Routine to get the load system record									*
;*==================================================================================*
save_Sys	proc
			mov		edi,offset FPath			; working path
			sub		eax,eax						;
			mov		ecx,64
			rep		stosd						; clear the destination buffer
			
			mov		esi,offset FilePath			; file path
			mov		edi,offset FPath			; working path
			mov		ebx,offset Sys_FileName		; system filename
			call	combine_path_file			; concentanate file name, path into working path

			mov		ebx,edi			
			mov		edi,offset WRecords			; EDI -> database
			mov		ecx,320						; record count

			call	save_DB						; save the database
			
			ret

save_Sys 	endp

;*==============================================================================*
;*			Routine to insert the columns into the listview control				*
;*==============================================================================*
InsertColumn proc	hwnd:DWORD
  			LOCAL 	lvc:LV_COLUMN 
  			
  			mov 	lvc.imask,LVCF_TEXT+LVCF_WIDTH 
  			mov 	lvc.pszText,offset Col_Website
  			mov 	lvc.lx,200 
  			invoke 	SendMessage,hwnd, LVM_INSERTCOLUMN, 0, addr lvc

  			or 		lvc.imask,LVCF_FMT
  			mov 	lvc.fmt,LVCFMT_LEFT 
  			mov 	lvc.pszText,offset Col_URL 
  			mov 	lvc.lx,200
  			invoke 	SendMessage,hwnd, LVM_INSERTCOLUMN, 1 ,addr lvc 

  			mov 	lvc.pszText,offset Col_User
  			mov 	lvc.lx,150
  			invoke 	SendMessage,hwnd, LVM_INSERTCOLUMN, 2 ,addr lvc 

  			mov 	lvc.pszText,offset Col_Pass
  			mov 	lvc.lx,150
  			invoke 	SendMessage,hwnd, LVM_INSERTCOLUMN, 3 ,addr lvc 

	  		ret 
InsertColumn endp

; #########################################################################

;*==================================================================================*
;*			Routine to convert binary into decimal ASCII characters	in string buffer*
;*----------------------------------------------------------------------------------*
;*			This routine will convert binary into decimal ASCII characters.			*
;*																					*
;*			Input:  EAX = Binary													*
;*					EDI -> Source buffer											*
;*					ECX = Number of digits to display								*
;*					Carry = 1, insert null character								*
;*																					*
;*			Registers changed: EDI, ECX												*
;*==================================================================================*
cnv_bin_dstr		proc
					;*====	Write spaces to the digit places	====
					push	ecx						; save string length
					push	eax						;  & binary value
					pushf							; save flag

					mov		al,20h					; AL = space
					rep		stosb					; write spaces into it
					
					popf							; restore ASCIIz string type flag
					jnc		cnvbind					; non-ASCIIz string
					
					mov		byte ptr [edi],0		; insert null character
					
			cnvbind:
					pop		eax						; restore binary value
					pop		ecx
					dec		edi						; adjust for 1 based offset
					
					;*====	Check if binary value is zero	====
					cmp		eax,00					; value is zero?
					jne		cnvbindon				; No, then convert
					
					mov		byte ptr [edi],30h		; indicate a zero value
					jmp		appnddsD
					
					;*====	Convert to ASCII	====
			cnvbindon:
					mov		bx,10					; divisor
			appndds:
					sub		edx,edx					; reset EDX
					cmp		eax,0					; conversion completed
					je		appnddsD				; Yes, continue
			
					;*----	Convert into decimal	----
					div		bx						; AX/BX
					add		dl,30h					; convert to ASCII code
					mov		[edi],dl				; 
					dec		edi						;
					dec		cl						; decrement digit count
					jne		appndds					;
					
					;*====	Check the flag	====
			appnddsD:
					ret								; conversion done
cnv_bin_dstr		endp


end start
